/*************************************************************************
    MDEMO.C
    James K. Lawless
    A demo of messagef(): a printf()-like variant of MessageBox()
**************************************************************************/

#include <windows.h>
#include <stdio.h>
#include <stdarg.h>


long FAR PASCAL WndProc (HWND, WORD, WORD, LONG) ;
int messagef(HWND, LPCSTR, UINT, LPCSTR, ...);

int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdParam, int nCmdShow)
{
   static char szAppName[] = "messagef() demo" ;
   WNDCLASS    wndclass;
   HWND        hWnd;
   MSG         msg ;

   if(!hPrevInstance) {
      wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
      wndclass.lpfnWndProc   = WndProc ;
      wndclass.cbClsExtra    = 0 ;
      wndclass.cbWndExtra    = 0 ;
      wndclass.hInstance     = hInstance ;
      wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
      wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
      wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;
      wndclass.lpszMenuName  = NULL ;
      wndclass.lpszClassName = szAppName ;

      RegisterClass (&wndclass) ;
   }
   hWnd = CreateWindow (szAppName,           // window class name
          "messagef() demo",                 // window caption
          WS_OVERLAPPEDWINDOW,               // window style
          CW_USEDEFAULT,                     // initial x position
          CW_USEDEFAULT,                     // initial y position
          CW_USEDEFAULT,                     // initial x size
          CW_USEDEFAULT,                     // initial y size
          NULL,                              // parent window handle
          NULL,                              // window menu handle
          hInstance,                         // program instance handle
          NULL) ;                            // creation parameters

   ShowWindow(hWnd, nCmdShow) ;
   UpdateWindow(hWnd);

   messagef(NULL,"messagef() demo", MB_OK,
      "Main window handle is %x ",hWnd);

   return msg.wParam ;
}


long FAR PASCAL WndProc (HWND hWnd, WORD message, WORD wParam, LONG lParam)
{
   return DefWindowProc(hWnd, message, wParam, lParam) ;
}


int messagef(HWND hWnd, LPCSTR lpszTitle, UINT uFlags, LPCSTR lpszFmt, ...)
{
#define BUF_SZ (1024)
   // Use ANSI variants of variable-argument
   // support macros.
   va_list arg;

   int i;

   // Work buffer for output string
   static char buff[BUF_SZ+1];

   // Isolate the first variable argument
   // into "arg"
   va_start(arg,lpszFmt);

   // Use _vsnprintf() to indirectly call sprintf()
   _vsnprintf(buff,BUF_SZ,lpszFmt,arg);

   // Display the output string via MessageBox()
   i=MessageBox(hWnd,buff,lpszTitle,uFlags);

   // Clean up..
   va_end(arg);

   // Return value from MessageBox() call
   return(i);
#undef BUF_SZ
}
